<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ddnsapi extends MX_Controller {

   /**
    * Index Page for this controller.
    *
    * Past the login page this loads the page for /ddns/ddnsapi.
    *
    */

   public function index() {

      $CI =& get_instance();

      // We load the BlueOnyx helper library first of all, as we heavily depend on it:
      $this->load->helper('blueonyx');
      init_libraries();

      // Need to load 'BxPage' for page rendering:
      $this->load->library('BxPage');

      // Force HTTPS:
      if (is_HTTPS() == FALSE) {
         $https_url = 'https://' . $_SERVER['SERVER_NAME'] . ':81/ddns/ddnsapi';
         header("Location: $https_url");
         exit;
      }

      // Get URL strings:
      $get_form_data = $CI->input->get(NULL, TRUE);

      //
      //-- Validate GET data:
      //

      $accessip = $this->input->ip_address();

      if ((isset($get_form_data['pw'])) && (isset($get_form_data['un']))) {

         $CI->BX_SESSION['loginName'] = $get_form_data['un'];
         setcookie("loginName", $CI->BX_SESSION['loginName'], time()+60*60*24*365, "/");

         $cceClient = new CceClient();
         $cceClient->connect();

         $sessionId = $cceClient->auth($CI->BX_SESSION['loginName'], $get_form_data['pw']);
         $CI->BX_SESSION['sessionId'] = $sessionId;
         setcookie("sessionId", $sessionId, "0", "/");
         $CI->setBX_SESSION($CI->BX_SESSION['loginName'], $CI->BX_SESSION['sessionId']);

         include_once('ServerScriptHelper.php');
         $CI->serverScriptHelper = new ServerScriptHelper($CI->BX_SESSION['sessionId'], $CI->BX_SESSION['loginName']);
         $CI->cceClient = $CI->serverScriptHelper->getCceClient();
      }

      // Shove submitted input into $form_data after passing it through the XSS filter:
      $form_data = $CI->input->post(NULL, TRUE);

      if ((isset($form_data['un'])) && (isset($form_data['pw']))) {

         $CI->BX_SESSION['loginName'] = $form_data['un'];
         setcookie("loginName", $CI->BX_SESSION['loginName'], time()+60*60*24*365, "/");

         $cceClient = new CceClient();
         $cceClient->connect();

         $sessionId = $cceClient->auth($CI->BX_SESSION['loginName'], $form_data['pw']);
         $CI->BX_SESSION['sessionId'] = $sessionId;
         setcookie("sessionId", $sessionId, "0", "/");
         $CI->setBX_SESSION($CI->BX_SESSION['loginName'], $CI->BX_SESSION['sessionId']);

         include_once('ServerScriptHelper.php');
         $CI->serverScriptHelper = new ServerScriptHelper($CI->BX_SESSION['sessionId'], $CI->BX_SESSION['loginName']);
         $CI->cceClient = $CI->serverScriptHelper->getCceClient();

      }

      // Get $sessionId and $loginName from Cookie (if they are set) and store them in $CI->BX_SESSION:
      $CI->BX_SESSION['loginName'] = $CI->input->cookie('loginName');
      $CI->BX_SESSION['sessionId'] = $CI->input->cookie('sessionId');
      if ($CI->BX_SESSION['sessionId'] != '') {
         $CI->BX_SESSION['sessionId'] = $CI->input->cookie('sessionId');
         $CI->setBX_SESSION($CI->BX_SESSION['loginName'], $CI->BX_SESSION['sessionId']);
      }

      // Chances are the bloody 'sessionId' cookie isn't set, so we grab it from $sessionId instead in order to proceed:
      if (isset($sessionId)) {
         $CI->setBX_SESSION($CI->BX_SESSION['loginName'], $sessionId);
      }

      // Line up the ducks for CCE-Connection and store them for re-usability in $CI:
      if (!isset($CI->serverScriptHelper)) {
         include_once('ServerScriptHelper.php');
         $CI->serverScriptHelper = new ServerScriptHelper($CI->BX_SESSION['sessionId'], $CI->BX_SESSION['loginName']);
         $CI->cceClient = $CI->serverScriptHelper->getCceClient();
      }

      $i18n = new I18n("base-subdomains", $CI->BX_SESSION['loginUser']['localePreference']);
      $system = $CI->getSystem();
      $user = $CI->BX_SESSION['loginUser'];

      // Initialize Capabilities so that we can poll the access rights as well:
      $Capabilities = new Capabilities($CI->cceClient, $CI->BX_SESSION['loginName'], $CI->BX_SESSION['sessionId']);

      // -- Actual page logic start:

      // Not 'serverDNS'? Bye, bye!
      if (!$Capabilities->getAllowed('serverDNS')) {
         // Nice people say goodbye, or CCEd waits forever:
         $CI->cceClient->bye();
         $CI->serverScriptHelper->destructor();
         Log403Error("/gui/Forbidden403");
      }

      //
      //--- Handle form validation:
      //

      // We start without any active errors:
      $errors = array();
      $extra_headers =array();
      $ci_errors = array();
      $my_errors = array();

      // Form fields that are required to have input:
      $required_keys = array();

      // Set up rules for form validation. These validations happen before we submit to CCE and further checks based on the schemas are done:

      // Empty array for key => values we want to submit to CCE:
      $attributes = array();
      // Items we do NOT want to submit to CCE:
      $ignore_attributes = array();
      if (is_array($form_data)) {
         // Function GetFormAttributes() walks through the $form_data and returns us the $parameters we want to
         // submit to CCE. It intelligently handles checkboxes, which only have "on" set when they are ticked.
         // In that case it pulls the unticked status from the hidden checkboxes and addes them to $parameters.
         // It also transformes the value of the ticked checkboxes from "on" to "1". 
         //
         // Additionally it generates the form_validation rules for CodeIgniter.
         //
         // params: $i18n           i18n Object of the error messages
         // params: $form_data         array with form_data array from CI
         // params: $required_keys     array with keys that must have data in it. Needed for CodeIgniter's error checks
         // params: $ignore_attributes array with items we want to ignore. Such as Labels.
         // return:                 array with keys and values ready to submit to CCE.
         $attributes = GetFormAttributes($i18n, $form_data, $required_keys, $ignore_attributes, $i18n);
      }
      //Setting up error messages:
      $CI->form_validation->set_message('required', $i18n->get("[[palette.val_is_required]]", false, array("field" => "\"%s\"")));     

      // Do we have validation related errors?
      if ($CI->form_validation->run() == FALSE) {

         if (validation_errors()) {
            // Set CI related errors:
            $ci_errors = array(validation_errors('<div class="alert dismissible alert_red"><img width="40" height="36" src="/.adm/images/icons/small/white/alarm_bell.png"><strong>', '</strong></div>'));
         }         
         else {
            // No errors. Pass empty array along:
            $ci_errors = array();
         }
      }

      //
      //--- Own error checks:
      //

      if ($CI->input->post(NULL, TRUE)) {
         // Not needed. Thank you, jQuery!
      }

      //
      //--- At this point all checks are done. If we have no errors, we can submit the data to CODB:
      //

      // Join the various error messages:
      $errors = array_merge($ci_errors, $my_errors);

      // If we have no errors and have POST data, we submit to CODB:
      if ((count($errors) == "0") && ($CI->input->post(NULL, TRUE))) {
         // Not needed.
      }

      //
      //-- Generate page:
      //

      // Prepare Page:
      $factory = $CI->serverScriptHelper->getHtmlComponentFactory("base-ddns", "/ddns/ddnsapi");
      $BxPage = $factory->getPage();
      $BxPage->setErrors($errors);
      $i18n = $factory->getI18n();

      // Set Menu items:
      $BxPage->setVerticalMenu('base_controlpanel');
      $BxPage->setVerticalMenuChild('base_ddns');
      $page_module = 'base_sysmanage';


      // Get CODB data:
      $DDNS = $CI->cceClient->get($system['OID'], "DDNS");

      $defaultPage = "basicSettingsTab";

      $block =& $factory->getPagedBlock("ddns_header", array($defaultPage));

      $block->setToggle("#");
      $block->setSideTabs(FALSE);
      $block->setDefaultPage($defaultPage);

      //--- Perform DNS Record updates:

      if ($DDNS['ddns_enabled'] == '1') {

         if (!$accessip) {
            $accessip = '127.0.0.1';
         }

         $update_domains = $CI->cceClient->scalar_to_array($DDNS['ddns_domains']);

         $need_daemon_restart = '0';
         foreach ($update_domains as $key => $DN) {
            $DNSoids = array();
            $DNSoids = $CI->cceClient->find("DnsSOA", array('domainname' => $DN));
            if ($DNSoids[0]) {
               $DNS_records = $CI->cceClient->find("DnsRecord", array('domainname' => $DN, 'type' => 'A'));
               foreach ($DNS_records as $key => $DR) {
                  $current_record = $CI->cceClient->get($DR);
                  if ($current_record['ipaddr'] != $accessip) {
                     $CI->cceClient->set($DR, '',  array('ipaddr' => $accessip));
                     $need_daemon_restart++;
                  }
               }
            }
         }
         if ($need_daemon_restart > '0') {
            $CI->cceClient->set($system['OID'], 'DNS',  array('commit' => time()));
         }

         $shorty = '|DNSOK| ';
         $msg = $i18n->get("dns_update_success");

      }
      else {
         $shorty = '|DNSFAIL| ';
         $msg = $i18n->get("dns_update_disabled");
      }

      $block->addFormField(
         $factory->getTextField("Status", $shorty . $msg . " $accessip", 'r'),
         $factory->getLabel("Status"),
         $defaultPage
      );

      // Get DNS Records:
      $DNS_SOAs = array();
      $DNSoids = $CI->cceClient->find("DnsSOA");

      foreach ($DNSoids as $key => $oid) {
         $rec = $CI->cceClient->get($oid, '');
         if ($rec['domainname'] != '') {
            $DNS_SOAs[$oid] = $rec['domainname'];
         }
      }

      $dval = $CI->cceClient->array_to_scalar(array_values($DNS_SOAs));

      // Build selector:
      $select_dnsRecords = $factory->getSetSelector('ddns_domains',
                             $DDNS['ddns_domains'], 
                             $dval,
                             'allowedAbilities', 'disallowedAbilities',
                             'r', 
                             $DDNS['ddns_domains'],
                             $dval
                         );
      $select_dnsRecords->setOptional(true);

      // Out with selector:
      $block->addFormField($select_dnsRecords, 
                 $factory->getLabel('ddns_domains'),
                 $defaultPage
                 );

      $page_body[] = $block->toHtml();

      // Out with the page:
      $BxPage->render($page_module, $page_body);

      // Delete sesssionId cookie:
      delete_cookie("sessionId");
      $CI->cceClient = new CceClient();
      $CI->cceClient->connect();

   }     
}
/*
Copyright (c) 2021 Michael Stauber, SOLARSPEED.NET
Copyright (c) 2021 Team BlueOnyx, BLUEONYX.IT
All Rights Reserved.

1. Redistributions of source code must retain the above copyright 
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright 
   notice, this list of conditions and the following disclaimer in 
   the documentation and/or other materials provided with the 
   distribution.

3. Neither the name of the copyright holder nor the names of its 
   contributors may be used to endorse or promote products derived 
   from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.

You acknowledge that this software is not designed or intended for 
use in the design, construction, operation or maintenance of any 
nuclear facility.

*/
?>